"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mapDefault = exports.mapLeftDefault = void 0;
/**
 * @since 3.0.0
 */
var function_1 = require("./function");
// -------------------------------------------------------------------------------------
// defaults
// -------------------------------------------------------------------------------------
/**
 * Return a default `mapLeft` implementation from `bimap`.
 *
 * @category defaults
 * @since 3.0.0
 */
var mapLeftDefault = function (bimap) {
    return function (f) {
        return bimap(f, function_1.identity);
    };
};
exports.mapLeftDefault = mapLeftDefault;
/**
 * Return a default `map` implementation from `bimap`.
 *
 * @category defaults
 * @since 3.0.0
 */
var mapDefault = function (bimap) {
    return function (f) {
        return bimap(function_1.identity, f);
    };
};
exports.mapDefault = mapDefault;
