"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.separate = exports.compact = exports.separateDefault = exports.compactDefault = void 0;
var function_1 = require("./function");
var FunctorModule = __importStar(require("./Functor"));
var SeparatedModule = __importStar(require("./Separated"));
var _ = __importStar(require("./internal"));
// -------------------------------------------------------------------------------------
// defaults
// -------------------------------------------------------------------------------------
/**
 * Return a default `compact` implementation from `Functor` and `separate`.
 *
 * @category defaults
 * @since 3.0.0
 */
var compactDefault = function (F) {
    return function (separate) {
        return (0, function_1.flow)(F.map(_.fromOption(function_1.constVoid)), separate, SeparatedModule.right);
    };
};
exports.compactDefault = compactDefault;
/**
 * Return a default `separate` implementation from `Functor` and `compact`.
 *
 * @category defaults
 * @since 3.0.0
 */
function separateDefault(F) {
    return function (compact) { return function (fe) {
        return SeparatedModule.separated((0, function_1.pipe)(fe, F.map(_.getLeft), compact), (0, function_1.pipe)(fe, F.map(_.getRight), compact));
    }; };
}
exports.separateDefault = separateDefault;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * `compact` composition.
 *
 * @category combinators
 * @since 3.0.0
 */
function compact(F, G) {
    return F.map(G.compact);
}
exports.compact = compact;
/**
 * `separate` composition.
 *
 * @category combinators
 * @since 3.0.0
 */
function separate(F, C, G) {
    var compactFC = compact(F, C);
    var mapFG = FunctorModule.map(F, G);
    return function (fge) {
        return SeparatedModule.separated((0, function_1.pipe)(fge, mapFG(_.getLeft), compactFC), (0, function_1.pipe)(fge, mapFG(_.getRight), compactFC));
    };
}
exports.separate = separate;
