"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getApplicative = exports.getApply = exports.flap = exports.Functor = exports.map = exports.Bifunctor = exports.Contravariant = exports.getBooleanAlgebra = exports.getHeytingAlgebra = exports.getRing = exports.getSemiring = exports.getMonoid = exports.getSemigroup = exports.getBounded = exports.getOrd = exports.getEq = exports.getShow = exports.mapLeft = exports.bimap = exports.contramap = exports.make = void 0;
var BifunctorModule = __importStar(require("./Bifunctor"));
var function_1 = require("./function");
var FunctorModule = __importStar(require("./Functor"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
exports.make = function_1.unsafeCoerce;
// -------------------------------------------------------------------------------------
// type class members
// -------------------------------------------------------------------------------------
/**
 * @category Contravariant
 * @since 3.0.0
 */
var contramap = function () { return function_1.unsafeCoerce; };
exports.contramap = contramap;
/**
 * Map a pair of functions over the two type arguments of the bifunctor.
 *
 * @category Bifunctor
 * @since 3.0.0
 */
var bimap = function (f) { return function (fea) {
    return (0, exports.make)(f(fea));
}; };
exports.bimap = bimap;
/**
 * Map a function over the first type argument of a bifunctor.
 *
 * @category Bifunctor
 * @since 3.0.0
 */
exports.mapLeft = 
/*#__PURE__*/ BifunctorModule.mapLeftDefault(exports.bimap);
// -------------------------------------------------------------------------------------
// instances
// -------------------------------------------------------------------------------------
/**
 * @category instances
 * @since 3.0.0
 */
var getShow = function (S) { return ({
    show: function (c) { return "make(".concat(S.show(c), ")"); }
}); };
exports.getShow = getShow;
/**
 * @category instances
 * @since 3.0.0
 */
exports.getEq = function_1.identity;
/**
 * @category instances
 * @since 3.0.0
 */
exports.getOrd = function_1.identity;
/**
 * @category instances
 * @since 3.0.0
 */
exports.getBounded = function_1.identity;
/**
 * @category instances
 * @since 3.0.0
 */
exports.getSemigroup = function_1.identity;
/**
 * @category instances
 * @since 3.0.0
 */
exports.getMonoid = function_1.identity;
/**
 * @category instances
 * @since 3.0.0
 */
exports.getSemiring = function_1.identity;
/**
 * @category instances
 * @since 3.0.0
 */
exports.getRing = function_1.identity;
/**
 * @category instances
 * @since 3.0.0
 */
exports.getHeytingAlgebra = function_1.identity;
/**
 * @category instances
 * @since 3.0.0
 */
exports.getBooleanAlgebra = function_1.identity;
/**
 * @category instances
 * @since 3.0.0
 */
exports.Contravariant = {
    contramap: exports.contramap
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Bifunctor = {
    bimap: exports.bimap,
    mapLeft: exports.mapLeft
};
/**
 * `map` can be used to turn functions `(a: A) => B` into functions `(fa: F<A>) => F<B>` whose argument and return types
 * use the type constructor `F` to represent some computational context.
 *
 * @category Functor
 * @since 3.0.0
 */
exports.map = 
/*#__PURE__*/ BifunctorModule.mapDefault(exports.bimap);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Functor = {
    map: exports.map
};
/**
 * Derivable from `Functor`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.flap = 
/*#__PURE__*/ FunctorModule.flap(exports.Functor);
/**
 * @category instances
 * @since 3.0.0
 */
var getApply = function (S) { return ({
    map: exports.map,
    ap: function (fa) { return function (fab) { return (0, exports.make)(S.concat(fa)(fab)); }; }
}); };
exports.getApply = getApply;
/**
 * @category instances
 * @since 3.0.0
 */
var getApplicative = function (M) {
    var A = (0, exports.getApply)(M);
    return {
        map: A.map,
        ap: A.ap,
        of: function () { return (0, exports.make)(M.empty); }
    };
};
exports.getApplicative = getApplicative;
