"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.bracket = exports.toUnion = exports.swap = exports.orElseFirst = exports.orLeft = exports.orElse = exports.getOrElseE = exports.getOrElse = exports.matchE = exports.match = exports.altValidation = exports.mapLeft = exports.bimap = exports.alt = exports.chain = exports.ap = exports.map = exports.leftF = exports.rightF = exports.left = exports.right = void 0;
/**
 * @since 3.0.0
 */
var ApplyModule = __importStar(require("./Apply"));
var EitherModule = __importStar(require("./Either"));
var function_1 = require("./function");
var FunctorModule = __importStar(require("./Functor"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
var right = function (F) {
    return function (a) {
        return F.of(EitherModule.right(a));
    };
};
exports.right = right;
/**
 * @since 3.0.0
 */
var left = function (F) {
    return function (e) {
        return F.of(EitherModule.left(e));
    };
};
exports.left = left;
/**
 * @since 3.0.0
 */
function rightF(F) {
    return F.map(EitherModule.right);
}
exports.rightF = rightF;
/**
 * @since 3.0.0
 */
function leftF(F) {
    return F.map(EitherModule.left);
}
exports.leftF = leftF;
// -------------------------------------------------------------------------------------
// type class members
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
var map = function (F) {
    return FunctorModule.map(F, EitherModule.Functor);
};
exports.map = map;
/**
 * @since 3.0.0
 */
var ap = function (F) {
    return ApplyModule.ap(F, EitherModule.Apply);
};
exports.ap = ap;
/**
 * @since 3.0.0
 */
var chain = function (M) {
    return function (f) {
        return function (ma) {
            return (0, function_1.pipe)(ma, M.chain(function (e) {
                return EitherModule.isLeft(e) ? M.of(e) : f(e.right);
            }));
        };
    };
};
exports.chain = chain;
/**
 * @since 3.0.0
 */
var alt = function (M) {
    return function (second) {
        return function (first) {
            return (0, function_1.pipe)(first, M.chain(function (e) {
                return EitherModule.isLeft(e) ? second() : M.of(e);
            }));
        };
    };
};
exports.alt = alt;
/**
 * @since 3.0.0
 */
function bimap(F) {
    return (0, function_1.flow)(EitherModule.bimap, F.map);
}
exports.bimap = bimap;
/**
 * @since 3.0.0
 */
function mapLeft(F) {
    return function (f) { return F.map(EitherModule.mapLeft(f)); };
}
exports.mapLeft = mapLeft;
/**
 * @since 3.0.0
 */
var altValidation = function (M, S) {
    return function (second) {
        return function (first) {
            var rightM = (0, exports.right)(M);
            return (0, function_1.pipe)(first, M.chain(EitherModule.match(function (e1) { return (0, function_1.pipe)(second(), M.map(EitherModule.mapLeft(function (e2) { return S.concat(e2)(e1); }))); }, rightM)));
        };
    };
};
exports.altValidation = altValidation;
// -------------------------------------------------------------------------------------
// destructors
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
function match(F) {
    return (0, function_1.flow)(EitherModule.match, F.map);
}
exports.match = match;
/**
 * @since 3.0.0
 */
var matchE = function (M) {
    return function (onLeft, onRight) {
        return M.chain(EitherModule.match(onLeft, onRight));
    };
};
exports.matchE = matchE;
/**
 * @since 3.0.0
 */
var getOrElse = function (F) {
    return function (onLeft) {
        return F.map(EitherModule.getOrElse(onLeft));
    };
};
exports.getOrElse = getOrElse;
/**
 * @since 3.0.0
 */
var getOrElseE = function (M) {
    return function (onLeft) {
        return function (ma) {
            return (0, function_1.pipe)(ma, M.chain(EitherModule.match(onLeft, M.of)));
        };
    };
};
exports.getOrElseE = getOrElseE;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
var orElse = function (M) {
    return function (onLeft) {
        return function (ma) {
            return (0, function_1.pipe)(ma, M.chain(function (e) {
                return EitherModule.isLeft(e) ? onLeft(e.left) : M.of(e);
            }));
        };
    };
};
exports.orElse = orElse;
/**
 * @since 3.0.0
 */
var orLeft = function (M) {
    return function (onLeft) {
        return function (fa) {
            return (0, function_1.pipe)(fa, M.chain(EitherModule.match(function (e) { return (0, function_1.pipe)(onLeft(e), M.map(EitherModule.left)); }, function (a) { return M.of(EitherModule.right(a)); })));
        };
    };
};
exports.orLeft = orLeft;
/**
 * @since 3.0.0
 */
var orElseFirst = function (M) {
    var orElseM = (0, exports.orElse)(M);
    return function (onLeft) {
        return function (ma) {
            return (0, function_1.pipe)(ma, orElseM(function (e) {
                return (0, function_1.pipe)(onLeft(e), M.map(function (eb) { return (EitherModule.isLeft(eb) ? eb : EitherModule.left(e)); }));
            }));
        };
    };
};
exports.orElseFirst = orElseFirst;
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
function swap(F) {
    return F.map(EitherModule.swap);
}
exports.swap = swap;
/**
 * @since 3.0.0
 */
function toUnion(F) {
    return F.map(EitherModule.toUnion);
}
exports.toUnion = toUnion;
/**
 * @since 3.0.0
 */
var bracket = function (M) {
    return function (acquire, use, release) {
        var leftM = (0, exports.left)(M);
        return (0, function_1.pipe)(acquire, M.chain(EitherModule.match(leftM, function (a) {
            return (0, function_1.pipe)(use(a), M.chain(function (e) {
                return (0, function_1.pipe)(release(a, e), M.chain(EitherModule.match(leftM, function () {
                    return M.of(e);
                })));
            }));
        })));
    };
};
exports.bracket = bracket;
