"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.partitionMap = exports.filterMap = exports.refinement = exports.partition = exports.refine = exports.filter = void 0;
var function_1 = require("./function");
var Separated_1 = require("./Separated");
var _ = __importStar(require("./internal"));
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
var filter = function (F) {
    return function (predicate) {
        return F.filterMap(function (b) { return (predicate(b) ? _.some(b) : _.none); });
    };
};
exports.filter = filter;
/**
 * @category combinators
 * @since 3.0.0
 */
var refine = function (F) {
    return function (refinement) {
        return F.filterMap(function (b) { return (refinement(b) ? _.some(b) : _.none); });
    };
};
exports.refine = refine;
/**
 * @category combinators
 * @since 3.0.0
 */
var partition = function (F) {
    return function (predicate) {
        return F.partitionMap(function (b) { return (predicate(b) ? _.right(b) : _.left(b)); });
    };
};
exports.partition = partition;
/**
 * @category combinators
 * @since 3.0.0
 */
var refinement = function (F) {
    return function (refinement) {
        return F.partitionMap(function (c) { return (refinement(c) ? _.right(c) : _.left(c)); });
    };
};
exports.refinement = refinement;
/**
 * `filterMap` composition.
 *
 * @category combinators
 * @since 3.0.0
 */
var filterMap = function (F, G) {
    return function (f) { return F.map(G.filterMap(f)); };
};
exports.filterMap = filterMap;
/**
 * `partitionMap` composition.
 *
 * @category combinators
 * @since 3.0.0
 */
var partitionMap = function (F, G) {
    var _filterMap = (0, exports.filterMap)(F, G);
    return function (f) { return function (fga) {
        return (0, Separated_1.separated)((0, function_1.pipe)(fga, _filterMap((0, function_1.flow)(f, _.getLeft))), (0, function_1.pipe)(fga, _filterMap((0, function_1.flow)(f, _.getRight))));
    }; };
};
exports.partitionMap = partitionMap;
