"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.refinementWithIndex = exports.partitionWithIndex = exports.refineWithIndex = exports.filterWithIndex = void 0;
var _ = __importStar(require("./internal"));
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
var filterWithIndex = function (F) {
    return function (predicate) {
        return F.filterMapWithIndex(function (i, b) { return (predicate(i, b) ? _.some(b) : _.none); });
    };
};
exports.filterWithIndex = filterWithIndex;
/**
 * @category combinators
 * @since 3.0.0
 */
var refineWithIndex = function (F) {
    return function (refinement) {
        return F.filterMapWithIndex(function (i, c) { return (refinement(i, c) ? _.some(c) : _.none); });
    };
};
exports.refineWithIndex = refineWithIndex;
/**
 * @category combinators
 * @since 3.0.0
 */
var partitionWithIndex = function (F) {
    return function (predicate) {
        return F.partitionMapWithIndex(function (i, b) { return (predicate(i, b) ? _.right(b) : _.left(b)); });
    };
};
exports.partitionWithIndex = partitionWithIndex;
/**
 * @category combinators
 * @since 3.0.0
 */
var refinementWithIndex = function (F) {
    return function (refinement) {
        return F.partitionMapWithIndex(function (i, c) { return (refinement(i, c) ? _.right(c) : _.left(c)); });
    };
};
exports.refinementWithIndex = refinementWithIndex;
