"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.chainNullableKOrElse = exports.fromNullableKOrElse = exports.fromNullableOrElse = exports.refineOrElse = exports.filterOrElse = exports.chainFirstEitherK = exports.chainEitherK = exports.fromEitherK = exports.chainOptionKOrElse = exports.fromOptionKOrElse = exports.fromRefinementOrElse = exports.fromPredicateOrElse = exports.fromOption = void 0;
/**
 * The `FromEither` type class represents those data types which support typed errors.
 *
 * @since 3.0.0
 */
var ChainModule = __importStar(require("./Chain"));
var function_1 = require("./function");
var _ = __importStar(require("./internal"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
var fromOption = function (F) {
    return function (onNone) {
        var fromOption = _.fromOption(onNone);
        return function (ma) { return F.fromEither(fromOption(ma)); };
    };
};
exports.fromOption = fromOption;
/**
 * @category constructors
 * @since 3.0.0
 */
var fromPredicateOrElse = function (F) {
    return function (predicate, onFalse) {
        return function (b) {
            return F.fromEither(predicate(b) ? _.right(b) : _.left(onFalse(b)));
        };
    };
};
exports.fromPredicateOrElse = fromPredicateOrElse;
/**
 * @category constructors
 * @since 3.0.0
 */
var fromRefinementOrElse = function (F) {
    return function (refinement, onFalse) {
        return function (c) {
            return F.fromEither(refinement(c) ? _.right(c) : _.left(onFalse(c)));
        };
    };
};
exports.fromRefinementOrElse = fromRefinementOrElse;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
var fromOptionKOrElse = function (F) {
    var fromOptionF = (0, exports.fromOption)(F);
    return function (onNone) {
        var from = fromOptionF(onNone);
        return function (f) {
            return function () {
                var a = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    a[_i] = arguments[_i];
                }
                return from(f.apply(void 0, a));
            };
        };
    };
};
exports.fromOptionKOrElse = fromOptionKOrElse;
/**
 * @category combinators
 * @since 3.0.0
 */
var chainOptionKOrElse = function (F, M) {
    var fromOptionKOrElseF = (0, exports.fromOptionKOrElse)(F);
    return function (onNone) {
        var from = fromOptionKOrElseF(onNone);
        return function (f) {
            var fromf = from(f);
            return function (ma) {
                return (0, function_1.pipe)(ma, M.chain(fromf));
            };
        };
    };
};
exports.chainOptionKOrElse = chainOptionKOrElse;
/**
 * @category combinators
 * @since 3.0.0
 */
var fromEitherK = function (F) {
    return function (f) {
        return function () {
            var a = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                a[_i] = arguments[_i];
            }
            return F.fromEither(f.apply(void 0, a));
        };
    };
};
exports.fromEitherK = fromEitherK;
/**
 * @category combinators
 * @since 3.0.0
 */
var chainEitherK = function (F, M) {
    var fromEitherKF = (0, exports.fromEitherK)(F);
    return function (f) {
        return function (ma) {
            return (0, function_1.pipe)(ma, M.chain(fromEitherKF(f)));
        };
    };
};
exports.chainEitherK = chainEitherK;
/**
 * @category combinators
 * @since 3.0.0
 */
var chainFirstEitherK = function (F, M) {
    var chainFirstM = ChainModule.chainFirst(M);
    var fromEitherKF = (0, exports.fromEitherK)(F);
    return function (f) {
        var fromEitherKFf = fromEitherKF(f);
        return chainFirstM(function (a) { return fromEitherKFf(a); });
    };
};
exports.chainFirstEitherK = chainFirstEitherK;
/**
 * @category combinators
 * @since 3.0.0
 */
var filterOrElse = function (F, M) {
    return function (predicate, onFalse) {
        return M.chain(function (b) { return F.fromEither(predicate(b) ? _.right(b) : _.left(onFalse(b))); });
    };
};
exports.filterOrElse = filterOrElse;
/**
 * @category combinators
 * @since 3.0.0
 */
var refineOrElse = function (F, M) {
    return function (refinement, onFalse) {
        return M.chain(function (c) { return F.fromEither(refinement(c) ? _.right(c) : _.left(onFalse(c))); });
    };
};
exports.refineOrElse = refineOrElse;
// -------------------------------------------------------------------------------------
// interop
// -------------------------------------------------------------------------------------
/**
 * @category interop
 * @since 3.0.0
 */
var fromNullableOrElse = function (F) {
    return function (onNullable) {
        return function (a) {
            return F.fromEither(_.fromNullableOrElse(onNullable)(a));
        };
    };
};
exports.fromNullableOrElse = fromNullableOrElse;
/**
 * @category interop
 * @since 3.0.0
 */
var fromNullableKOrElse = function (F) {
    var fromNullableOrElseF = (0, exports.fromNullableOrElse)(F);
    return function (onNullable) {
        var fromNullable = fromNullableOrElseF(onNullable);
        return function (f) {
            return function () {
                var a = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    a[_i] = arguments[_i];
                }
                return fromNullable(f.apply(void 0, a));
            };
        };
    };
};
exports.fromNullableKOrElse = fromNullableKOrElse;
/**
 * @category interop
 * @since 3.0.0
 */
var chainNullableKOrElse = function (F, M) {
    var fromNullableKM = (0, exports.fromNullableKOrElse)(F);
    return function (onNullable) {
        var fromNullable = fromNullableKM(onNullable);
        return function (f) {
            return function (ma) {
                return (0, function_1.pipe)(ma, M.chain(fromNullable(f)));
            };
        };
    };
};
exports.chainNullableKOrElse = chainNullableKOrElse;
