"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.chainNullableK = exports.fromNullableK = exports.fromNullable = exports.fromOptionK = exports.fromRefinement = exports.fromPredicate = void 0;
var function_1 = require("./function");
var _ = __importStar(require("./internal"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
var fromPredicate = function (F) {
    return function (predicate) {
        return function (b) {
            return F.fromOption(predicate(b) ? _.some(b) : _.none);
        };
    };
};
exports.fromPredicate = fromPredicate;
/**
 * @category constructors
 * @since 3.0.0
 */
var fromRefinement = function (F) {
    return function (refinement) {
        return function (c) {
            return F.fromOption(refinement(c) ? _.some(c) : _.none);
        };
    };
};
exports.fromRefinement = fromRefinement;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
var fromOptionK = function (F) {
    return function (f) {
        return function () {
            var a = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                a[_i] = arguments[_i];
            }
            return F.fromOption(f.apply(void 0, a));
        };
    };
};
exports.fromOptionK = fromOptionK;
// -------------------------------------------------------------------------------------
// interop
// -------------------------------------------------------------------------------------
/**
 * @category interop
 * @since 3.0.0
 */
var fromNullable = function (F) {
    return function (a) {
        return F.fromOption(_.fromNullable(a));
    };
};
exports.fromNullable = fromNullable;
/**
 * @category interop
 * @since 3.0.0
 */
var fromNullableK = function (F) {
    var fromNullableF = (0, exports.fromNullable)(F);
    return function (f) {
        return function () {
            var a = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                a[_i] = arguments[_i];
            }
            return fromNullableF(f.apply(void 0, a));
        };
    };
};
exports.fromNullableK = fromNullableK;
/**
 * @category interop
 * @since 3.0.0
 */
var chainNullableK = function (F, C) {
    var fromNullableKF = (0, exports.fromNullableK)(F);
    return function (f) {
        return function (ma) {
            return (0, function_1.pipe)(ma, C.chain(fromNullableKF(f)));
        };
    };
};
exports.chainNullableK = chainNullableK;
