"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.chainFirstReaderK = exports.chainReaderK = exports.fromReaderK = exports.asks = exports.ask = void 0;
/**
 * Lift a computation from the `Reader` monad.
 *
 * @since 3.0.0
 */
var ChainModule = __importStar(require("./Chain"));
var function_1 = require("./function");
var _ = __importStar(require("./internal"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
function ask(F) {
    return function () { return F.fromReader(_.ask()); };
}
exports.ask = ask;
/**
 * @category constructors
 * @since 3.0.0
 */
function asks(F) {
    return F.fromReader;
}
exports.asks = asks;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
var fromReaderK = function (F) {
    return function (f) {
        return function () {
            var a = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                a[_i] = arguments[_i];
            }
            return F.fromReader(f.apply(void 0, a));
        };
    };
};
exports.fromReaderK = fromReaderK;
/**
 * @category combinators
 * @since 3.0.0
 */
var chainReaderK = function (F, M) {
    return function (f) {
        return function (ma) {
            return (0, function_1.pipe)(ma, M.chain(function (a) { return F.fromReader(f(a)); }));
        };
    };
};
exports.chainReaderK = chainReaderK;
/**
 * @category combinators
 * @since 3.0.0
 */
var chainFirstReaderK = function (F, M) {
    var chainFirstM = ChainModule.chainFirst(M);
    return function (f) { return chainFirstM(function (a) { return F.fromReader(f(a)); }); };
};
exports.chainFirstReaderK = chainFirstReaderK;
