"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.chainStateK = exports.fromStateK = exports.gets = exports.modify = exports.put = exports.get = void 0;
var StateModule = __importStar(require("./State"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
function get(F) {
    return function () { return F.fromState(StateModule.get()); };
}
exports.get = get;
/**
 * @category constructors
 * @since 3.0.0
 */
function put(F) {
    return function (s) { return F.fromState(StateModule.put(s)); };
}
exports.put = put;
/**
 * @category constructors
 * @since 3.0.0
 */
var modify = function (F) {
    return function (f) {
        return F.fromState(StateModule.modify(f));
    };
};
exports.modify = modify;
/**
 * @category constructors
 * @since 3.0.0
 */
var gets = function (F) {
    return function (f) {
        return F.fromState(StateModule.gets(f));
    };
};
exports.gets = gets;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
var fromStateK = function (F) {
    return function (f) {
        return function () {
            var a = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                a[_i] = arguments[_i];
            }
            return F.fromState(f.apply(void 0, a));
        };
    };
};
exports.fromStateK = fromStateK;
/**
 * @category combinators
 * @since 3.0.0
 */
var chainStateK = function (F, M) {
    return function (f) { return M.chain(function (a) { return F.fromState(f(a)); }); };
};
exports.chainStateK = chainStateK;
