"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.chainFirstTaskK = exports.chainTaskK = exports.fromTaskK = void 0;
/**
 * Lift a computation from the `Task` monad.
 *
 * @since 3.0.0
 */
var ChainModule = __importStar(require("./Chain"));
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
var fromTaskK = function (F) {
    return function (f) {
        return function () {
            var a = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                a[_i] = arguments[_i];
            }
            return F.fromTask(f.apply(void 0, a));
        };
    };
};
exports.fromTaskK = fromTaskK;
/**
 * @category combinators
 * @since 3.0.0
 */
var chainTaskK = function (F, M) {
    return function (f) { return M.chain(function (a) { return F.fromTask(f(a)); }); };
};
exports.chainTaskK = chainTaskK;
/**
 * @category combinators
 * @since 3.0.0
 */
var chainFirstTaskK = function (F, M) {
    var chainFirstM = ChainModule.chainFirst(M);
    return function (f) { return chainFirstM(function (a) { return F.fromTask(f(a)); }); };
};
exports.chainFirstTaskK = chainFirstTaskK;
