"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fromOption = exports.FromEither = exports.chainFirstIOK = exports.chainIOK = exports.fromIOK = exports.FromIO = exports.Alt = exports.Monad = exports.chainFirst = exports.ApplicativeSeq = exports.ApplySeq = exports.Chain = exports.ApplicativePar = exports.apSecond = exports.apFirst = exports.ApplyPar = exports.Bifunctor = exports.Pointed = exports.flap = exports.Functor = exports.getFilterable = exports.getCompactable = exports.getAltIOValidation = exports.getApplicativeIOValidation = exports.alt = exports.flatten = exports.chain = exports.of = exports.ap = exports.mapLeft = exports.bimap = exports.map = exports.swap = exports.orLeft = exports.orElseFirstIOK = exports.orElseFirst = exports.orElse = exports.toUnion = exports.tryCatchK = exports.tryCatch = exports.getOrElseE = exports.getOrElse = exports.matchE = exports.match = exports.fromIO = exports.fromEither = exports.leftIO = exports.rightIO = exports.right = exports.left = void 0;
exports.sequenceReadonlyArraySeq = exports.traverseReadonlyArraySeq = exports.traverseReadonlyNonEmptyArraySeq = exports.traverseReadonlyArrayWithIndexSeq = exports.traverseReadonlyNonEmptyArrayWithIndexSeq = exports.sequenceReadonlyArray = exports.traverseReadonlyArray = exports.traverseReadonlyNonEmptyArray = exports.traverseReadonlyArrayWithIndex = exports.traverseReadonlyNonEmptyArrayWithIndex = exports.apT = exports.tupled = exports.ApT = exports.apS = exports.bind = exports.let = exports.bindTo = exports.Do = exports.bracket = exports.chainNullableKOrElse = exports.fromNullableKOrElse = exports.fromNullableOrElse = exports.fromEitherK = exports.refineOrElse = exports.filterOrElse = exports.fromRefinementOrElse = exports.fromPredicateOrElse = exports.chainFirstEitherK = exports.chainEitherK = exports.chainOptionKOrElse = exports.fromOptionKOrElse = void 0;
var ApplyModule = __importStar(require("./Apply"));
var ChainModule = __importStar(require("./Chain"));
var CompactableModule = __importStar(require("./Compactable"));
var EitherModule = __importStar(require("./Either"));
var EitherTModule = __importStar(require("./EitherT"));
var FilterableModule = __importStar(require("./Filterable"));
var FromEitherModule = __importStar(require("./FromEither"));
var FromIOModule = __importStar(require("./FromIO"));
var function_1 = require("./function");
var FunctorModule = __importStar(require("./Functor"));
var _ = __importStar(require("./internal"));
var IOModule = __importStar(require("./IO"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
exports.left = EitherTModule.left(IOModule.Pointed);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.right = EitherTModule.right(IOModule.Pointed);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.rightIO = EitherTModule.rightF(IOModule.Functor);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.leftIO = EitherTModule.leftF(IOModule.Functor);
// -------------------------------------------------------------------------------------
// natural transformations
// -------------------------------------------------------------------------------------
/**
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromEither = IOModule.of;
/**
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromIO = exports.rightIO;
// -------------------------------------------------------------------------------------
// destructors
// -------------------------------------------------------------------------------------
/**
 * @category destructors
 * @since 3.0.0
 */
exports.match = 
/*#__PURE__*/ EitherTModule.match(IOModule.Functor);
/**
 * @category destructors
 * @since 3.0.0
 */
exports.matchE = EitherTModule.matchE(IOModule.Monad);
/**
 * @category destructors
 * @since 3.0.0
 */
exports.getOrElse = 
/*#__PURE__*/ EitherTModule.getOrElse(IOModule.Functor);
/**
 * @category destructors
 * @since 3.0.0
 */
exports.getOrElseE = 
/*#__PURE__*/ EitherTModule.getOrElseE(IOModule.Monad);
// -------------------------------------------------------------------------------------
// interop
// -------------------------------------------------------------------------------------
/**
 * Constructs a new `IOEither` from a function that performs a side effect and might throw.
 *
 * See also [`tryCatchK`](#tryCatchK).
 *
 * @category interop
 * @since 3.0.0
 */
var tryCatch = function (f, onThrow) {
    return function () {
        return EitherModule.tryCatch(f, onThrow);
    };
};
exports.tryCatch = tryCatch;
/**
 * Converts a function that may throw to one returning a `IOEither`.
 *
 * @category interop
 * @since 3.0.0
 */
var tryCatchK = function (f, onThrow) {
    return function () {
        var a = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            a[_i] = arguments[_i];
        }
        return (0, exports.tryCatch)(function () { return f.apply(void 0, a); }, onThrow);
    };
};
exports.tryCatchK = tryCatchK;
/**
 * @category interop
 * @since 3.0.0
 */
exports.toUnion = EitherTModule.toUnion(IOModule.Functor);
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
exports.orElse = EitherTModule.orElse(IOModule.Monad);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.orElseFirst = EitherTModule.orElseFirst(IOModule.Monad);
/**
 * @category combinators
 * @since 3.0.0
 */
var orElseFirstIOK = function (onLeft) {
    return (0, exports.orElseFirst)((0, exports.fromIOK)(onLeft));
};
exports.orElseFirstIOK = orElseFirstIOK;
/**
 * @category combinators
 * @since 3.0.0
 */
exports.orLeft = 
/*#__PURE__*/ EitherTModule.orLeft(IOModule.Monad);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.swap = EitherTModule.swap(IOModule.Functor);
// -------------------------------------------------------------------------------------
// type class members
// -------------------------------------------------------------------------------------
/**
 * `map` can be used to turn functions `(a: A) => B` into functions `(fa: F<A>) => F<B>` whose argument and return types
 * use the type constructor `F` to represent some computational context.
 *
 * @category Functor
 * @since 3.0.0
 */
exports.map = EitherTModule.map(IOModule.Functor);
/**
 * Map a pair of functions over the two type arguments of the bifunctor.
 *
 * @category Bifunctor
 * @since 3.0.0
 */
exports.bimap = 
/*#__PURE__*/ EitherTModule.bimap(IOModule.Functor);
/**
 * Map a function over the first type argument of a bifunctor.
 *
 * @category Bifunctor
 * @since 3.0.0
 */
exports.mapLeft = 
/*#__PURE__*/ EitherTModule.mapLeft(IOModule.Functor);
/**
 * Apply a function to an argument under a type constructor.
 *
 * @category Apply
 * @since 3.0.0
 */
exports.ap = 
/*#__PURE__*/ EitherTModule.ap(IOModule.Apply);
/**
 * @category Pointed
 * @since 3.0.0
 */
exports.of = exports.right;
/**
 * Composes computations in sequence, using the return value of one computation to determine the next computation.
 *
 * @category Chain
 * @since 3.0.0
 */
exports.chain = 
/*#__PURE__*/ EitherTModule.chain(IOModule.Monad);
/**
 * Derivable from `Chain`.
 *
 * @category derivable combinators
 * @since 3.0.0
 */
exports.flatten = 
/*#__PURE__*/ (0, exports.chain)(function_1.identity);
/**
 * Identifies an associative operation on a type constructor. It is similar to `Semigroup`, except that it applies to
 * types of kind `* -> *`.
 *
 * @category Alt
 * @since 3.0.0
 */
exports.alt = 
/*#__PURE__*/ EitherTModule.alt(IOModule.Monad);
// -------------------------------------------------------------------------------------
// instances
// -------------------------------------------------------------------------------------
/**
 * The default [`ApplicativePar`](#applicativepar) instance returns the first error, if you want to
 * get all errors you need to provide an way to concatenate them via a `Semigroup`.
 *
 * See [`getApplicativeValidation`](./Either.ts.html#getapplicativevalidation).
 *
 * @category instances
 * @since 3.0.0
 */
var getApplicativeIOValidation = function (S) { return ({
    map: exports.map,
    ap: ApplyModule.ap(IOModule.Apply, EitherModule.getApplicativeValidation(S)),
    of: exports.of
}); };
exports.getApplicativeIOValidation = getApplicativeIOValidation;
/**
 * The default [`Alt`](#alt) instance returns the last error, if you want to
 * get all errors you need to provide an way to concatenate them via a `Semigroup`.
 *
 * See [`getAltValidation`](./Either.ts.html#getaltvalidation).
 *
 * @category instances
 * @since 3.0.0
 */
var getAltIOValidation = function (S) {
    return {
        map: exports.map,
        alt: EitherTModule.altValidation(IOModule.Monad, S)
    };
};
exports.getAltIOValidation = getAltIOValidation;
/**
 * @category instances
 * @since 3.0.0
 */
var getCompactable = function (M) {
    var C = EitherModule.getCompactable(M);
    var F = { map: EitherModule.map };
    return {
        compact: CompactableModule.compact(IOModule.Functor, C),
        separate: CompactableModule.separate(IOModule.Functor, C, F)
    };
};
exports.getCompactable = getCompactable;
/**
 * @category instances
 * @since 3.0.0
 */
var getFilterable = function (M) {
    var F = EitherModule.getFilterable(M);
    return {
        filterMap: FilterableModule.filterMap(IOModule.Functor, F),
        partitionMap: FilterableModule.partitionMap(IOModule.Functor, F)
    };
};
exports.getFilterable = getFilterable;
/**
 * @category instances
 * @since 3.0.0
 */
exports.Functor = {
    map: exports.map
};
/**
 * Derivable from `Functor`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.flap = 
/*#__PURE__*/ FunctorModule.flap(exports.Functor);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Pointed = {
    of: exports.of
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Bifunctor = {
    bimap: exports.bimap,
    mapLeft: exports.mapLeft
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.ApplyPar = {
    map: exports.map,
    ap: exports.ap
};
/**
 * Combine two effectful actions, keeping only the result of the first.
 *
 * Derivable from `Apply`.
 *
 * @category derivable combinators
 * @since 3.0.0
 */
exports.apFirst = 
/*#__PURE__*/ ApplyModule.apFirst(exports.ApplyPar);
/**
 * Combine two effectful actions, keeping only the result of the second.
 *
 * Derivable from `Apply`.
 *
 * @category derivable combinators
 * @since 3.0.0
 */
exports.apSecond = 
/*#__PURE__*/ ApplyModule.apSecond(exports.ApplyPar);
/**
 * @category instances
 * @since 3.0.0
 */
exports.ApplicativePar = {
    map: exports.map,
    ap: exports.ap,
    of: exports.of
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Chain = {
    map: exports.map,
    chain: exports.chain
};
var apSeq = /*#__PURE__*/ ChainModule.ap(exports.Chain);
/**
 * @category instances
 * @since 3.0.0
 */
exports.ApplySeq = {
    map: exports.map,
    ap: apSeq
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.ApplicativeSeq = {
    map: exports.map,
    ap: apSeq,
    of: exports.of
};
/**
 * Composes computations in sequence, using the return value of one computation to determine the next computation and
 * keeping only the result of the first.
 *
 * Derivable from `Chain`.
 *
 * @category derivable combinators
 * @since 3.0.0
 */
exports.chainFirst = ChainModule.chainFirst(exports.Chain);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Monad = {
    map: exports.map,
    of: exports.of,
    chain: exports.chain
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Alt = {
    map: exports.map,
    alt: exports.alt
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.FromIO = {
    fromIO: exports.fromIO
};
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromIOK = FromIOModule.fromIOK(exports.FromIO);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.chainIOK = 
/*#__PURE__*/ FromIOModule.chainIOK(exports.FromIO, exports.Chain);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.chainFirstIOK = 
/*#__PURE__*/ FromIOModule.chainFirstIOK(exports.FromIO, exports.Chain);
/**
 * @category instances
 * @since 3.0.0
 */
exports.FromEither = {
    fromEither: exports.fromEither
};
/**
 * Derivable from `FromEither`.
 *
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromOption = 
/*#__PURE__*/ FromEitherModule.fromOption(exports.FromEither);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromOptionKOrElse = 
/*#__PURE__*/ FromEitherModule.fromOptionKOrElse(exports.FromEither);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.chainOptionKOrElse = 
/*#__PURE__*/ FromEitherModule.chainOptionKOrElse(exports.FromEither, exports.Chain);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.chainEitherK = 
/*#__PURE__*/ FromEitherModule.chainEitherK(exports.FromEither, exports.Chain);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.chainFirstEitherK = FromEitherModule.chainFirstEitherK(exports.FromEither, exports.Chain);
/**
 * Derivable from `FromEither`.
 *
 * @category constructors
 * @since 3.0.0
 */
exports.fromPredicateOrElse = FromEitherModule.fromPredicateOrElse(exports.FromEither);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.fromRefinementOrElse = FromEitherModule.fromRefinementOrElse(exports.FromEither);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.filterOrElse = FromEitherModule.filterOrElse(exports.FromEither, exports.Chain);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.refineOrElse = FromEitherModule.refineOrElse(exports.FromEither, exports.Chain);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromEitherK = FromEitherModule.fromEitherK(exports.FromEither);
/**
 * @category interop
 * @since 3.0.0
 */
exports.fromNullableOrElse = 
/*#__PURE__*/ FromEitherModule.fromNullableOrElse(exports.FromEither);
/**
 * @category interop
 * @since 3.0.0
 */
exports.fromNullableKOrElse = FromEitherModule.fromNullableKOrElse(exports.FromEither);
/**
 * @category interop
 * @since 3.0.0
 */
exports.chainNullableKOrElse = 
/*#__PURE__*/ FromEitherModule.chainNullableKOrElse(exports.FromEither, exports.Chain);
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * Make sure that a resource is cleaned up in the event of an exception (\*). The release action is called regardless of
 * whether the body action throws (\*) or returns.
 *
 * (\*) i.e. returns a `Left`
 *
 * @since 3.0.0
 */
exports.bracket = EitherTModule.bracket(IOModule.Monad);
// -------------------------------------------------------------------------------------
// do notation
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.Do = (0, exports.of)(_.emptyRecord);
/**
 * @since 3.0.0
 */
exports.bindTo = FunctorModule.bindTo(exports.Functor);
var let_ = 
/*#__PURE__*/ FunctorModule.let(exports.Functor);
exports.let = let_;
/**
 * @since 3.0.0
 */
exports.bind = 
/*#__PURE__*/ ChainModule.bind(exports.Chain);
// -------------------------------------------------------------------------------------
// sequence S
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.apS = 
/*#__PURE__*/ ApplyModule.apS(exports.ApplyPar);
// -------------------------------------------------------------------------------------
// sequence T
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.ApT = (0, exports.of)(_.emptyReadonlyArray);
/**
 * @since 3.0.0
 */
exports.tupled = 
/*#__PURE__*/ FunctorModule.tupled(exports.Functor);
/**
 * @since 3.0.0
 */
exports.apT = 
/*#__PURE__*/ ApplyModule.apT(exports.ApplyPar);
// -------------------------------------------------------------------------------------
// array utils
// -------------------------------------------------------------------------------------
// --- Par ---
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverseWithIndex(ApplyPar)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArrayWithIndex = function (f) {
    return (0, function_1.flow)(IOModule.traverseReadonlyNonEmptyArrayWithIndex(f), IOModule.map(EitherModule.traverseReadonlyNonEmptyArrayWithIndex(function_1.SK)));
};
exports.traverseReadonlyNonEmptyArrayWithIndex = traverseReadonlyNonEmptyArrayWithIndex;
/**
 * Equivalent to `ReadonlyArray#traverseWithIndex(ApplicativePar)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArrayWithIndex = function (f) {
    var g = (0, exports.traverseReadonlyNonEmptyArrayWithIndex)(f);
    return function (as) { return (_.isNonEmpty(as) ? g(as) : exports.ApT); };
};
exports.traverseReadonlyArrayWithIndex = traverseReadonlyArrayWithIndex;
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverse(ApplyPar)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArray = function (f) {
    return (0, exports.traverseReadonlyNonEmptyArrayWithIndex)(function (_, a) { return f(a); });
};
exports.traverseReadonlyNonEmptyArray = traverseReadonlyNonEmptyArray;
/**
 * Equivalent to `ReadonlyArray#traverse(ApplicativePar)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArray = function (f) {
    return (0, exports.traverseReadonlyArrayWithIndex)(function (_, a) { return f(a); });
};
exports.traverseReadonlyArray = traverseReadonlyArray;
/**
 * Equivalent to `ReadonlyArray#sequence(ApplicativePar)`.
 *
 * @since 3.0.0
 */
exports.sequenceReadonlyArray = 
/*#__PURE__*/ (0, exports.traverseReadonlyArray)(function_1.identity);
// --- Seq ---
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverseWithIndex(ApplySeq)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArrayWithIndexSeq = function (f) {
    return function (as) {
        return function () {
            var e = f(0, _.head(as))();
            if (_.isLeft(e)) {
                return e;
            }
            var out = [e.right];
            for (var i = 1; i < as.length; i++) {
                var e_1 = f(i, as[i])();
                if (_.isLeft(e_1)) {
                    return e_1;
                }
                out.push(e_1.right);
            }
            return _.right(out);
        };
    };
};
exports.traverseReadonlyNonEmptyArrayWithIndexSeq = traverseReadonlyNonEmptyArrayWithIndexSeq;
/**
 * Equivalent to `ReadonlyArray#traverseWithIndex(ApplicativeSeq)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArrayWithIndexSeq = function (f) {
    var g = (0, exports.traverseReadonlyNonEmptyArrayWithIndexSeq)(f);
    return function (as) { return (_.isNonEmpty(as) ? g(as) : exports.ApT); };
};
exports.traverseReadonlyArrayWithIndexSeq = traverseReadonlyArrayWithIndexSeq;
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverse(ApplySeq)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArraySeq = function (f) {
    return (0, exports.traverseReadonlyNonEmptyArrayWithIndexSeq)(function (_, a) { return f(a); });
};
exports.traverseReadonlyNonEmptyArraySeq = traverseReadonlyNonEmptyArraySeq;
/**
 * Equivalent to `ReadonlyArray#traverse(ApplicativeSeq)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArraySeq = function (f) {
    return (0, exports.traverseReadonlyArrayWithIndexSeq)(function (_, a) { return f(a); });
};
exports.traverseReadonlyArraySeq = traverseReadonlyArraySeq;
/**
 * Equivalent to `ReadonlyArray#sequence(ApplicativeSeq)`.
 *
 * @since 3.0.0
 */
exports.sequenceReadonlyArraySeq = 
/*#__PURE__*/ (0, exports.traverseReadonlyArraySeq)(function_1.identity);
