"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fromRefinement = exports.fromPredicate = exports.FromOption = exports.chainFirstIOK = exports.chainIOK = exports.fromIOK = exports.FromIO = exports.refinement = exports.partition = exports.refine = exports.filter = exports.Filterable = exports.Compactable = exports.Monad = exports.Alternative = exports.guard = exports.Zero = exports.Alt = exports.chainFirst = exports.Chain = exports.Applicative = exports.apSecond = exports.apFirst = exports.Apply = exports.Pointed = exports.flap = exports.Functor = exports.partitionMap = exports.filterMap = exports.separate = exports.compact = exports.none = exports.zero = exports.alt = exports.flatten = exports.chain = exports.of = exports.ap = exports.map = exports.toNullable = exports.toUndefined = exports.getOrElseE = exports.getOrElse = exports.matchE = exports.match = exports.fromIOEither = exports.fromIO = exports.fromEither = exports.fromOption = exports.some = void 0;
exports.sequenceReadonlyArray = exports.traverseReadonlyArray = exports.traverseReadonlyNonEmptyArray = exports.traverseReadonlyArrayWithIndex = exports.traverseReadonlyNonEmptyArrayWithIndex = exports.ApT = exports.apS = exports.bind = exports.let = exports.bindTo = exports.Do = exports.chainFirstEitherK = exports.chainEitherK = exports.fromEitherK = exports.FromEither = exports.chainNullableK = exports.fromNullableK = exports.fromNullable = exports.fromOptionK = void 0;
var ApplyModule = __importStar(require("./Apply"));
var ChainModule = __importStar(require("./Chain"));
var CompactableModule = __importStar(require("./Compactable"));
var FilterableModule = __importStar(require("./Filterable"));
var FromOptionModule = __importStar(require("./FromOption"));
var FromEitherModule = __importStar(require("./FromEither"));
var FromIOModule = __importStar(require("./FromIO"));
var function_1 = require("./function");
var FunctorModule = __importStar(require("./Functor"));
var _ = __importStar(require("./internal"));
var IOModule = __importStar(require("./IO"));
var OptionModule = __importStar(require("./Option"));
var OptionTModule = __importStar(require("./OptionT"));
var ZeroModule = __importStar(require("./Zero"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
exports.some = OptionTModule.some(IOModule.Pointed);
// -------------------------------------------------------------------------------------
// natural transformations
// -------------------------------------------------------------------------------------
/**
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromOption = IOModule.of;
/**
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromEither = 
/*#__PURE__*/ OptionTModule.fromEither(IOModule.Pointed);
/**
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromIO = OptionTModule.fromF(IOModule.Functor);
/**
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromIOEither = IOModule.map(OptionModule.fromEither);
// -------------------------------------------------------------------------------------
// destructors
// -------------------------------------------------------------------------------------
/**
 * @category destructors
 * @since 3.0.0
 */
exports.match = 
/*#__PURE__*/ OptionTModule.match(IOModule.Functor);
/**
 * @category destructors
 * @since 3.0.0
 */
exports.matchE = 
/*#__PURE__*/ OptionTModule.matchE(IOModule.Chain);
/**
 * @category destructors
 * @since 3.0.0
 */
exports.getOrElse = 
/*#__PURE__*/ OptionTModule.getOrElse(IOModule.Functor);
/**
 * @category destructors
 * @since 3.0.0
 */
exports.getOrElseE = 
/*#__PURE__*/ OptionTModule.getOrElseE(IOModule.Monad);
/**
 * @category destructors
 * @since 3.0.0
 */
exports.toUndefined = IOModule.map(OptionModule.toUndefined);
/**
 * @category destructors
 * @since 3.0.0
 */
exports.toNullable = IOModule.map(OptionModule.toNullable);
// -------------------------------------------------------------------------------------
// type class members
// -------------------------------------------------------------------------------------
/**
 * `map` can be used to turn functions `(a: A) => B` into functions `(fa: F<A>) => F<B>` whose argument and return types
 * use the type constructor `F` to represent some computational context.
 *
 * @category Functor
 * @since 3.0.0
 */
exports.map = OptionTModule.map(IOModule.Functor);
/**
 * @category Apply
 * @since 3.0.0
 */
exports.ap = 
/*#__PURE__*/ OptionTModule.ap(IOModule.Apply);
/**
 * @category Pointed
 * @since 3.0.0
 */
exports.of = exports.some;
/**
 * Composes computations in sequence, using the return value of one computation to determine the next computation.
 *
 * @category Chain
 * @since 3.0.0
 */
exports.chain = 
/*#__PURE__*/ OptionTModule.chain(IOModule.Monad);
/**
 * Derivable from `Chain`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.flatten = (0, exports.chain)(function_1.identity);
/**
 * @category Alt
 * @since 3.0.0
 */
exports.alt = 
/*#__PURE__*/ OptionTModule.alt(IOModule.Monad);
/**
 * @category Zero
 * @since 3.0.0
 */
exports.zero = OptionTModule.zero(IOModule.Pointed);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.none = (0, exports.zero)();
/**
 * @category Compactable
 * @since 3.0.0
 */
exports.compact = 
/*#__PURE__*/ CompactableModule.compact(IOModule.Functor, OptionModule.Compactable);
/**
 * @category Compactable
 * @since 3.0.0
 */
exports.separate = 
/*#__PURE__*/ CompactableModule.separate(IOModule.Functor, OptionModule.Compactable, OptionModule.Functor);
/**
 * @category Filterable
 * @since 3.0.0
 */
exports.filterMap = 
/*#__PURE__*/ FilterableModule.filterMap(IOModule.Functor, OptionModule.Filterable);
/**
 * @category Filterable
 * @since 3.0.0
 */
exports.partitionMap = FilterableModule.partitionMap(IOModule.Functor, OptionModule.Filterable);
// -------------------------------------------------------------------------------------
// instances
// -------------------------------------------------------------------------------------
/**
 * @category instances
 * @since 3.0.0
 */
exports.Functor = {
    map: exports.map
};
/**
 * Derivable from `Functor`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.flap = 
/*#__PURE__*/ FunctorModule.flap(exports.Functor);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Pointed = {
    of: exports.of
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Apply = {
    map: exports.map,
    ap: exports.ap
};
/**
 * Combine two effectful actions, keeping only the result of the first.
 *
 * Derivable from `Apply`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.apFirst = 
/*#__PURE__*/ ApplyModule.apFirst(exports.Apply);
/**
 * Combine two effectful actions, keeping only the result of the second.
 *
 * Derivable from `Apply`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.apSecond = 
/*#__PURE__*/ ApplyModule.apSecond(exports.Apply);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Applicative = {
    map: exports.map,
    ap: exports.ap,
    of: exports.of
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Chain = {
    map: exports.map,
    chain: exports.chain
};
/**
 * Composes computations in sequence, using the return value of one computation to determine the next computation and
 * keeping only the result of the first.
 *
 * Derivable from `Chain`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.chainFirst = 
/*#__PURE__*/ ChainModule.chainFirst(exports.Chain);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Alt = {
    map: exports.map,
    alt: exports.alt
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Zero = {
    zero: exports.zero
};
/**
 * @category constructors
 * @since 3.0.0
 */
exports.guard = ZeroModule.guard(exports.Zero, exports.Pointed);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Alternative = {
    map: exports.map,
    alt: exports.alt,
    zero: exports.zero
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Monad = {
    map: exports.map,
    of: exports.of,
    chain: exports.chain
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Compactable = {
    compact: exports.compact,
    separate: exports.separate
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Filterable = {
    filterMap: exports.filterMap,
    partitionMap: exports.partitionMap
};
/**
 * @since 3.0.0
 */
exports.filter = 
/*#__PURE__*/ FilterableModule.filter(exports.Filterable);
/**
 * @since 3.0.0
 */
exports.refine = FilterableModule.refine(exports.Filterable);
/**
 * @since 3.0.0
 */
exports.partition = FilterableModule.partition(exports.Filterable);
/**
 * @since 3.0.0
 */
exports.refinement = FilterableModule.refinement(exports.Filterable);
/**
 * @category instances
 * @since 3.0.0
 */
exports.FromIO = {
    fromIO: exports.fromIO
};
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromIOK = FromIOModule.fromIOK(exports.FromIO);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.chainIOK = 
/*#__PURE__*/ FromIOModule.chainIOK(exports.FromIO, exports.Chain);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.chainFirstIOK = 
/*#__PURE__*/ FromIOModule.chainFirstIOK(exports.FromIO, exports.Chain);
/**
 * @category instances
 * @since 3.0.0
 */
exports.FromOption = {
    fromOption: exports.fromOption
};
/**
 * @category constructors
 * @since 3.0.0
 */
exports.fromPredicate = 
/*#__PURE__*/ FromOptionModule.fromPredicate(exports.FromOption);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.fromRefinement = 
/*#__PURE__*/ FromOptionModule.fromRefinement(exports.FromOption);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromOptionK = 
/*#__PURE__*/ FromOptionModule.fromOptionK(exports.FromOption);
// -------------------------------------------------------------------------------------
// interop
// -------------------------------------------------------------------------------------
/**
 * @category interop
 * @since 3.0.0
 */
exports.fromNullable = 
/*#__PURE__*/ FromOptionModule.fromNullable(exports.FromOption);
/**
 * @category interop
 * @since 3.0.0
 */
exports.fromNullableK = FromOptionModule.fromNullableK(exports.FromOption);
/**
 * @category interop
 * @since 3.0.0
 */
exports.chainNullableK = FromOptionModule.chainNullableK(exports.FromOption, exports.Chain);
/**
 * @category instances
 * @since 3.0.0
 */
exports.FromEither = {
    fromEither: exports.fromEither
};
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromEitherK = FromEitherModule.fromEitherK(exports.FromEither);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.chainEitherK = 
/*#__PURE__*/ FromEitherModule.chainEitherK(exports.FromEither, exports.Chain);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.chainFirstEitherK = 
/*#__PURE__*/ FromEitherModule.chainFirstEitherK(exports.FromEither, exports.Chain);
// -------------------------------------------------------------------------------------
// do notation
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.Do = (0, exports.of)(_.emptyRecord);
/**
 * @since 3.0.0
 */
exports.bindTo = 
/*#__PURE__*/ FunctorModule.bindTo(exports.Functor);
var let_ = 
/*#__PURE__*/ FunctorModule.let(exports.Functor);
exports.let = let_;
/**
 * @since 3.0.0
 */
exports.bind = 
/*#__PURE__*/ ChainModule.bind(exports.Chain);
// -------------------------------------------------------------------------------------
// sequence S
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.apS = 
/*#__PURE__*/ ApplyModule.apS(exports.Apply);
// -------------------------------------------------------------------------------------
// sequence T
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.ApT = (0, exports.of)(_.emptyReadonlyArray);
// -------------------------------------------------------------------------------------
// array utils
// -------------------------------------------------------------------------------------
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverseWithIndex(Apply)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArrayWithIndex = function (f) {
    return (0, function_1.flow)(IOModule.traverseReadonlyNonEmptyArrayWithIndex(f), IOModule.map(OptionModule.traverseReadonlyNonEmptyArrayWithIndex(function_1.SK)));
};
exports.traverseReadonlyNonEmptyArrayWithIndex = traverseReadonlyNonEmptyArrayWithIndex;
/**
 * Equivalent to `ReadonlyArray#traverseWithIndex(Applicative)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArrayWithIndex = function (f) {
    var g = (0, exports.traverseReadonlyNonEmptyArrayWithIndex)(f);
    return function (as) { return (_.isNonEmpty(as) ? g(as) : exports.ApT); };
};
exports.traverseReadonlyArrayWithIndex = traverseReadonlyArrayWithIndex;
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverse(Apply)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArray = function (f) {
    return (0, exports.traverseReadonlyNonEmptyArrayWithIndex)(function (_, a) { return f(a); });
};
exports.traverseReadonlyNonEmptyArray = traverseReadonlyNonEmptyArray;
/**
 * Equivalent to `ReadonlyArray#traverse(Applicative)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArray = function (f) {
    return (0, exports.traverseReadonlyArrayWithIndex)(function (_, a) { return f(a); });
};
exports.traverseReadonlyArray = traverseReadonlyArray;
/**
 * Equivalent to `ReadonlyArray#sequence(Applicative)`.
 *
 * @since 3.0.0
 */
exports.sequenceReadonlyArray = 
/*#__PURE__*/ (0, exports.traverseReadonlyArray)(function_1.identity);
