"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.zero = exports.alt = exports.chain = exports.ap = exports.map = exports.getOrElseE = exports.getOrElse = exports.matchE = exports.match = exports.fromEither = exports.fromF = exports.some = void 0;
/**
 * @since 3.0.0
 */
var ApplyModule = __importStar(require("./Apply"));
var function_1 = require("./function");
var FunctorModule = __importStar(require("./Functor"));
var _ = __importStar(require("./internal"));
var OptionModule = __importStar(require("./Option"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
var some = function (F) {
    return function (a) {
        return F.of(_.some(a));
    };
};
exports.some = some;
// -------------------------------------------------------------------------------------
// natural transformations
// -------------------------------------------------------------------------------------
/**
 * @category natural transformations
 * @since 3.0.0
 */
function fromF(F) {
    return F.map(_.some);
}
exports.fromF = fromF;
/**
 * @category natural transformations
 * @since 3.0.0
 */
var fromEither = function (F) {
    return function (e) {
        return F.of(OptionModule.fromEither(e));
    };
};
exports.fromEither = fromEither;
// -------------------------------------------------------------------------------------
// destructors
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
function match(F) {
    return (0, function_1.flow)(OptionModule.match, F.map);
}
exports.match = match;
/**
 * @since 3.0.0
 */
var matchE = function (M) {
    return function (onNone, onSome) {
        return M.chain(OptionModule.match(onNone, onSome));
    };
};
exports.matchE = matchE;
/**
 * @since 3.0.0
 */
var getOrElse = function (F) {
    return function (onNone) {
        return F.map(OptionModule.getOrElse(onNone));
    };
};
exports.getOrElse = getOrElse;
/**
 * @since 3.0.0
 */
var getOrElseE = function (M) {
    return function (onNone) {
        return function (ma) {
            return (0, function_1.pipe)(ma, M.chain(OptionModule.match(onNone, M.of)));
        };
    };
};
exports.getOrElseE = getOrElseE;
// -------------------------------------------------------------------------------------
// type class members
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
function map(F) {
    return FunctorModule.map(F, OptionModule.Functor);
}
exports.map = map;
/**
 * @since 3.0.0
 */
var ap = function (F) {
    return ApplyModule.ap(F, OptionModule.Apply);
};
exports.ap = ap;
/**
 * @since 3.0.0
 */
var chain = function (M) {
    return function (f) {
        return function (ma) {
            return (0, function_1.pipe)(ma, M.chain(OptionModule.match(function () { return zero(M)(); }, f)));
        };
    };
};
exports.chain = chain;
/**
 * @since 3.0.0
 */
var alt = function (M) {
    return function (second) {
        return function (first) {
            return (0, function_1.pipe)(first, M.chain(OptionModule.match(second, (0, exports.some)(M))));
        };
    };
};
exports.alt = alt;
/**
 * @since 3.0.0
 */
function zero(F) {
    return (0, function_1.constant)(F.of(_.none));
}
exports.zero = zero;
