"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sequenceReadonlyArray = exports.traverseReadonlyArray = exports.traverseReadonlyNonEmptyArray = exports.traverseReadonlyArrayWithIndex = exports.traverseReadonlyNonEmptyArrayWithIndex = exports.tupled = exports.let = exports.bindTo = exports.getFromTask = exports.getFromIO = exports.getFromReader = exports.fromWriterK = exports.FromWriter = exports.getMonad = exports.getChain = exports.getApplicative = exports.getApply = exports.getPointed = exports.flap = exports.Functor = exports.Bifunctor = exports.mapSnd = exports.mapFst = exports.bimap = exports.mapLeft = exports.map = exports.censor = exports.listens = exports.pass = exports.listen = exports.fromReaderWriterK = exports.fromTaskWriterK = exports.swap = exports.local = exports.execute = exports.evaluate = exports.snd = exports.fst = exports.fromReaderWriter = exports.fromWriter = exports.asksReaderTaskWriter = exports.tell = exports.fromTask = exports.fromIO = exports.fromTaskWriter = exports.fromReaderTask = exports.fromReader = void 0;
var FromWriterModule = __importStar(require("./FromWriter"));
var function_1 = require("./function");
var FunctorModule = __importStar(require("./Functor"));
var _ = __importStar(require("./internal"));
var ReaderModule = __importStar(require("./Reader"));
var ReaderTaskModule = __importStar(require("./ReaderTask"));
var ReadonlyNonEmptyArrayModule = __importStar(require("./ReadonlyNonEmptyArray"));
var TaskModule = __importStar(require("./Task"));
var WriterTModule = __importStar(require("./WriterT"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
var fromReader = function (w) {
    return function (fa) {
        return (0, exports.fromReaderTask)(w)(ReaderTaskModule.fromReader(fa));
    };
};
exports.fromReader = fromReader;
/**
 * @category constructors
 * @since 3.0.0
 */
exports.fromReaderTask = 
/*#__PURE__*/ WriterTModule.fromF(ReaderTaskModule.Functor);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.fromTaskWriter = 
/*#__PURE__*/ ReaderModule.of;
/**
 * @category constructors
 * @since 3.0.0
 */
exports.fromIO = 
/*#__PURE__*/ WriterTModule.fromIO(ReaderTaskModule.Functor, ReaderTaskModule.FromIO);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.fromTask = 
/*#__PURE__*/ WriterTModule.fromTask(ReaderTaskModule.Functor, ReaderTaskModule.FromTask);
/**
 * Appends a value to the accumulator
 *
 * @category constructors
 * @since 3.0.0
 */
exports.tell = WriterTModule.tell(ReaderTaskModule.Pointed);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.asksReaderTaskWriter = ReaderModule.asksReader;
// -------------------------------------------------------------------------------------
// natural transformations
// -------------------------------------------------------------------------------------
/**
 * @category natural transformations
 * @since 3.0.0
 */
var fromWriter = function (w) { return ReaderTaskModule.of(w); };
exports.fromWriter = fromWriter;
/**
 * @category natural transformations
 * @since 3.0.0
 */
var fromReaderWriter = function (fa) {
    return (0, function_1.flow)(fa, TaskModule.of);
};
exports.fromReaderWriter = fromReaderWriter;
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.fst = WriterTModule.fst(ReaderTaskModule.Functor);
/**
 * @since 3.0.0
 */
exports.snd = WriterTModule.snd(ReaderTaskModule.Functor);
/**
 * Alias of [`fst`](#fst).
 *
 * @since 3.0.0
 */
exports.evaluate = exports.fst;
/**
 * Alias of [`snd`](#snd).
 *
 * @since 3.0.0
 */
exports.execute = exports.snd;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * Changes the value of the local context during the execution of the action `ma` (similar to `Contravariant`'s
 * `contramap`).
 *
 * @category combinators
 * @since 3.0.0
 */
exports.local = ReaderModule.local;
/**
 * @since 3.0.0
 */
exports.swap = 
/*#__PURE__*/ WriterTModule.swap(ReaderTaskModule.Functor);
/**
 * @category combinators
 * @since 3.0.0
 */
var fromTaskWriterK = function (f) {
    return function () {
        var a = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            a[_i] = arguments[_i];
        }
        return (0, exports.fromTaskWriter)(f.apply(void 0, a));
    };
};
exports.fromTaskWriterK = fromTaskWriterK;
/**
 * @category combinators
 * @since 3.0.0
 */
var fromReaderWriterK = function (f) { return (0, function_1.flow)(f, exports.fromReaderWriter); };
exports.fromReaderWriterK = fromReaderWriterK;
/**
 * @since 3.0.0
 */
exports.listen = 
/*#__PURE__*/ WriterTModule.listen(ReaderTaskModule.Functor);
/**
 * @since 3.0.0
 */
exports.pass = 
/*#__PURE__*/ WriterTModule.pass(ReaderTaskModule.Functor);
/**
 * @since 3.0.0
 */
exports.listens = 
/*#__PURE__*/ WriterTModule.listens(ReaderTaskModule.Functor);
/**
 * @since 3.0.0
 */
exports.censor = 
/*#__PURE__*/ WriterTModule.censor(ReaderTaskModule.Functor);
// -------------------------------------------------------------------------------------
// type class operations
// -------------------------------------------------------------------------------------
/**
 * `map` can be used to turn functions `(a: A) => B` into functions `(fa: F<A>) => F<B>` whose argument and return types
 * use the type constructor `F` to represent some computational context.
 *
 * @category type class operations
 * @since 3.0.0
 */
exports.map = 
/*#__PURE__*/ WriterTModule.map(ReaderTaskModule.Functor);
/**
 * @category type class operations
 * @since 3.0.0
 */
exports.mapLeft = 
/*#__PURE__*/ WriterTModule.mapLeft(ReaderTaskModule.Functor);
/**
 * Map a pair of functions over the two type arguments of the bifunctor.
 *
 * @category type class operations
 * @since 3.0.0
 */
exports.bimap = WriterTModule.bimap(ReaderTaskModule.Functor);
/**
 * Maps a function over the first component of a `Writer`.
 *
 * Alias of [`map`](#map)
 *
 * @since 3.0.0
 */
exports.mapFst = exports.map;
/**
 * Maps a function over the second component of a `Writer`.
 *
 * Alias of [`mapLeft`](#mapleft)
 *
 * @since 3.0.0
 */
exports.mapSnd = exports.mapLeft;
// -------------------------------------------------------------------------------------
// instances
// -------------------------------------------------------------------------------------
/**
 * @category instances
 * @since 3.0.0
 */
exports.Bifunctor = {
    bimap: exports.bimap,
    mapLeft: exports.mapSnd
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Functor = {
    map: exports.map
};
/**
 * Derivable from `Functor`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.flap = 
/*#__PURE__*/ FunctorModule.flap(exports.Functor);
/**
 * @category instances
 * @since 3.0.0
 */
var getPointed = function (M) { return ({
    of: WriterTModule.of(ReaderTaskModule.Pointed, M)
}); };
exports.getPointed = getPointed;
/**
 * @category instances
 * @since 3.0.0
 */
var getApply = function (A, S) { return ({
    map: exports.map,
    ap: WriterTModule.ap(A, S)
}); };
exports.getApply = getApply;
/**
 * @category instances
 * @since 3.0.0
 */
var getApplicative = function (A, M) {
    var ap = (0, exports.getApply)(A, M).ap;
    var P = (0, exports.getPointed)(M);
    return {
        map: exports.map,
        ap: ap,
        of: P.of
    };
};
exports.getApplicative = getApplicative;
/**
 * @category instances
 * @since 3.0.0
 */
var getChain = function (S) {
    return {
        map: exports.map,
        chain: WriterTModule.chain(ReaderTaskModule.Chain, S)
    };
};
exports.getChain = getChain;
/**
 * @category instances
 * @since 3.0.0
 */
var getMonad = function (M) {
    var P = (0, exports.getPointed)(M);
    var C = (0, exports.getChain)(M);
    return {
        map: exports.map,
        of: P.of,
        chain: C.chain
    };
};
exports.getMonad = getMonad;
/**
 * @category instances
 * @since 3.0.0
 */
exports.FromWriter = {
    fromWriter: exports.fromWriter
};
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromWriterK = FromWriterModule.fromWriterK(exports.FromWriter);
/**
 * @category instances
 * @since 3.0.0
 */
var getFromReader = function (M) { return ({
    fromReader: (0, exports.fromReader)(M.empty)
}); };
exports.getFromReader = getFromReader;
/**
 * @category instances
 * @since 3.0.0
 */
var getFromIO = function (M) { return ({
    fromIO: (0, exports.fromIO)(M.empty)
}); };
exports.getFromIO = getFromIO;
/**
 * @category instances
 * @since 3.0.0
 */
var getFromTask = function (M) { return ({
    fromIO: (0, exports.fromIO)(M.empty),
    fromTask: (0, exports.fromTask)(M.empty)
}); };
exports.getFromTask = getFromTask;
// -------------------------------------------------------------------------------------
// do notation
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.bindTo = 
/*#__PURE__*/ FunctorModule.bindTo(exports.Functor);
var let_ = 
/*#__PURE__*/ FunctorModule.let(exports.Functor);
exports.let = let_;
// -------------------------------------------------------------------------------------
// sequence T
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.tupled = 
/*#__PURE__*/ FunctorModule.tupled(exports.Functor);
// -------------------------------------------------------------------------------------
// array utils
// -------------------------------------------------------------------------------------
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverseWithIndex(getApply(A, M))`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArrayWithIndex = function (A, S) {
    return function (f) {
        return function (as) {
            // TODO
            return ReadonlyNonEmptyArrayModule.traverseWithIndex((0, exports.getApply)(A, S))(f)(as);
        };
    };
};
exports.traverseReadonlyNonEmptyArrayWithIndex = traverseReadonlyNonEmptyArrayWithIndex;
/**
 * Equivalent to `ReadonlyArray#traverseWithIndex(getApplicative(A, M))`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArrayWithIndex = function (A, M) {
    return function (f) {
        var g = (0, exports.traverseReadonlyNonEmptyArrayWithIndex)(A, M)(f);
        var P = (0, exports.getPointed)(M);
        return function (as) { return (_.isNonEmpty(as) ? g(as) : P.of(_.emptyReadonlyArray)); };
    };
};
exports.traverseReadonlyArrayWithIndex = traverseReadonlyArrayWithIndex;
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverse(getApply(A, M))`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArray = function (A, S) {
    var traverseReadonlyNonEmptyArrayWithIndexAM = (0, exports.traverseReadonlyNonEmptyArrayWithIndex)(A, S);
    return function (f) {
        return traverseReadonlyNonEmptyArrayWithIndexAM(function (_, a) { return f(a); });
    };
};
exports.traverseReadonlyNonEmptyArray = traverseReadonlyNonEmptyArray;
/**
 * Equivalent to `ReadonlyArray#traverse(getApplicative(A, M))`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArray = function (A, M) {
    var traverseReadonlyArrayWithIndexAM = (0, exports.traverseReadonlyArrayWithIndex)(A, M);
    return function (f) {
        return traverseReadonlyArrayWithIndexAM(function (_, a) { return f(a); });
    };
};
exports.traverseReadonlyArray = traverseReadonlyArray;
/**
 * Equivalent to `ReadonlyArray#sequence(getApplicative(A, M))`.
 *
 * @since 3.0.0
 */
var sequenceReadonlyArray = function (A, M) {
    return (0, exports.traverseReadonlyArray)(A, M)(function_1.identity);
};
exports.sequenceReadonlyArray = sequenceReadonlyArray;
