"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.toTuple2 = exports.swap = exports.matchE = exports.match = exports.mapLeft = exports.bimap = exports.chain = exports.ap = exports.map = exports.leftF = exports.rightF = exports.both = exports.left = exports.right = void 0;
/**
 * @since 3.0.0
 */
var Apply_1 = require("./Apply");
var function_1 = require("./function");
var Functor_1 = require("./Functor");
var T = __importStar(require("./These"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
var right = function (F) {
    return function (a) {
        return F.of(T.right(a));
    };
};
exports.right = right;
/**
 * @since 3.0.0
 */
var left = function (F) {
    return function (e) {
        return F.of(T.left(e));
    };
};
exports.left = left;
/**
 * @since 3.0.0
 */
var both = function (F) {
    return function (e, a) {
        return F.of(T.both(e, a));
    };
};
exports.both = both;
/**
 * @since 3.0.0
 */
function rightF(F) {
    return F.map(T.right);
}
exports.rightF = rightF;
/**
 * @since 3.0.0
 */
function leftF(F) {
    return F.map(T.left);
}
exports.leftF = leftF;
// -------------------------------------------------------------------------------------
// type class members
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
function map(F) {
    return (0, Functor_1.map)(F, T.Functor);
}
exports.map = map;
/**
 * @since 3.0.0
 */
var ap = function (F, S) {
    return (0, Apply_1.ap)(F, T.getApply(S));
};
exports.ap = ap;
/**
 * @since 3.0.0
 */
var chain = function (M, S) {
    var _left = (0, exports.left)(M);
    return function (f) {
        return function (ma) {
            return (0, function_1.pipe)(ma, M.chain(T.match(_left, f, function (e1, a) {
                return (0, function_1.pipe)(f(a), M.map(T.match(function (e2) { return T.left(S.concat(e2)(e1)); }, function (b) { return T.both(e1, b); }, function (e2, b) { return T.both(S.concat(e2)(e1), b); })));
            })));
        };
    };
};
exports.chain = chain;
/**
 * @since 3.0.0
 */
function bimap(F) {
    return (0, function_1.flow)(T.bimap, F.map);
}
exports.bimap = bimap;
/**
 * @since 3.0.0
 */
function mapLeft(F) {
    return function (f) { return F.map(T.mapLeft(f)); };
}
exports.mapLeft = mapLeft;
// -------------------------------------------------------------------------------------
// destructors
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
function match(F) {
    return (0, function_1.flow)(T.match, F.map);
}
exports.match = match;
/**
 * @since 3.0.0
 */
var matchE = function (M) {
    return function (onLeft, onRight, onBoth) {
        return M.chain(T.match(onLeft, onRight, onBoth));
    };
};
exports.matchE = matchE;
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
function swap(F) {
    return F.map(T.swap);
}
exports.swap = swap;
/**
 * @since 3.0.0
 */
function toTuple2(F) {
    return (0, function_1.flow)(T.toTuple2, F.map);
}
exports.toTuple2 = toTuple2;
