"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.traverse = exports.sequence = void 0;
var function_1 = require("./function");
// -------------------------------------------------------------------------------------
// defaults
// -------------------------------------------------------------------------------------
/**
 * Return a default `sequence` implementation from `traverse`.
 *
 * @category defaults
 * @since 3.0.0
 */
var sequence = function (F) {
    return function (G) {
        return F.traverse(G)(function_1.identity);
    };
};
exports.sequence = sequence;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * `traverse` composition.
 *
 * @category combinators
 * @since 3.0.0
 */
var traverse = function (F, G) {
    return function (H) {
        return function (f) {
            return F.traverse(H)(G.traverse(H)(f));
        };
    };
};
exports.traverse = traverse;
