"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sequenceReadonlyArray = exports.traverseReadonlyArray = exports.traverseReadonlyNonEmptyArray = exports.traverseReadonlyArrayWithIndex = exports.traverseReadonlyNonEmptyArrayWithIndex = exports.getChainRec = exports.getMonad = exports.getChain = exports.getApplicative = exports.getApply = exports.getPointed = exports.sequence = exports.Traversable = exports.Foldable = exports.Comonad = exports.Semigroupoid = exports.flap = exports.Functor = exports.Bifunctor = exports.traverse = exports.reduceRight = exports.foldMap = exports.reduce = exports.duplicate = exports.extract = exports.extend = exports.compose = exports.mapSnd = exports.mapFst = exports.bimap = exports.mapLeft = exports.map = exports.censor = exports.listens = exports.pass = exports.listen = exports.swap = exports.execute = exports.evaluate = exports.snd = exports.fst = exports.tell = exports.fromIdentity = void 0;
var function_1 = require("./function");
var Functor_1 = require("./Functor");
var _ = __importStar(require("./internal"));
var ReadonlyNonEmptyArrayModule = __importStar(require("./ReadonlyNonEmptyArray"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
var fromIdentity = function (w) {
    return function (a) {
        return [a, w];
    };
}; // TODO name?
exports.fromIdentity = fromIdentity;
/**
 * Appends a value to the accumulator
 *
 * @category constructors
 * @since 3.0.0
 */
var tell = function (w) { return [undefined, w]; };
exports.tell = tell;
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
var fst = function (t) { return t[0]; };
exports.fst = fst;
/**
 * @since 3.0.0
 */
var snd = function (t) { return t[1]; };
exports.snd = snd;
/**
 * Alias of [`fst`](#fst).
 *
 * @since 3.0.0
 */
exports.evaluate = exports.fst;
/**
 * Alias of [`snd`](#snd).
 *
 * @since 3.0.0
 */
exports.execute = exports.snd;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
var swap = function (t) { return [(0, exports.snd)(t), (0, exports.fst)(t)]; };
exports.swap = swap;
/**
 * Modifies the result to include the changes to the accumulator
 *
 * @category combinators
 * @since 3.0.0
 */
var listen = function (fa) {
    var a = fa[0], w = fa[1];
    return [[a, w], w];
};
exports.listen = listen;
/**
 * Applies the returned function to the accumulator
 *
 * @category combinators
 * @since 3.0.0
 */
var pass = function (fa) {
    var _a = fa[0], a = _a[0], f = _a[1], w = fa[1];
    return [a, f(w)];
};
exports.pass = pass;
/**
 * Projects a value from modifications made to the accumulator during an action
 *
 * @category combinators
 * @since 3.0.0
 */
var listens = function (f) { return function (fa) {
    var a = fa[0], w = fa[1];
    return [[a, f(w)], w];
}; };
exports.listens = listens;
/**
 * Modify the final accumulator value by applying a function
 *
 * @category combinators
 * @since 3.0.0
 */
var censor = function (f) { return function (fa) {
    var a = fa[0], w = fa[1];
    return [a, f(w)];
}; };
exports.censor = censor;
// -------------------------------------------------------------------------------------
// type class operations
// -------------------------------------------------------------------------------------
/**
 * `map` can be used to turn functions `(a: A) => B` into functions `(fa: F<A>) => F<B>` whose argument and return types
 * use the type constructor `F` to represent some computational context.
 *
 * @category type class operations
 * @since 3.0.0
 */
var map = function (f) { return function (fa) {
    var a = fa[0], w = fa[1];
    return [f(a), w];
}; };
exports.map = map;
/**
 * @category type class operations
 * @since 3.0.0
 */
var mapLeft = function (f) { return function (fa) {
    var a = fa[0], w = fa[1];
    return [a, f(w)];
}; };
exports.mapLeft = mapLeft;
/**
 * Map a pair of functions over the two type arguments of the bifunctor.
 *
 * @category type class operations
 * @since 3.0.0
 */
var bimap = function (mapSnd, mapFst) {
    return function (t) {
        return [mapFst((0, exports.fst)(t)), mapSnd((0, exports.snd)(t))];
    };
};
exports.bimap = bimap;
/**
 * Maps a function over the first component of a `Writer`.
 *
 * Alias of [`map`](#map)
 *
 * @since 3.0.0
 */
exports.mapFst = exports.map;
/**
 * Maps a function over the second component of a `Writer`.
 *
 * Alias of [`mapLeft`](#mapleft)
 *
 * @since 3.0.0
 */
exports.mapSnd = exports.mapLeft;
/**
 * @category type class operations
 * @since 3.0.0
 */
var compose = function (bc) { return function (ab) {
    return [(0, exports.fst)(bc), (0, exports.snd)(ab)];
}; };
exports.compose = compose;
/**
 * @category type class operations
 * @since 3.0.0
 */
var extend = function (f) { return function (wa) {
    return [f(wa), (0, exports.snd)(wa)];
}; };
exports.extend = extend;
/**
 * @category type class operations
 * @since 3.0.0
 */
exports.extract = exports.fst;
/**
 * Derivable from `Extend`.
 *
 * @category type class operations
 * @since 3.0.0
 */
exports.duplicate = (0, exports.extend)(function_1.identity);
/**
 * @category type class operations
 * @since 3.0.0
 */
var reduce = function (b, f) { return function (fa) { return f(b, (0, exports.fst)(fa)); }; };
exports.reduce = reduce;
/**
 * @category type class operations
 * @since 3.0.0
 */
var foldMap = function () { return function (f) { return function (fa) {
    return f((0, exports.fst)(fa));
}; }; };
exports.foldMap = foldMap;
/**
 * @category type class operations
 * @since 3.0.0
 */
var reduceRight = function (b, f) { return function (fa) {
    return f((0, exports.fst)(fa), b);
}; };
exports.reduceRight = reduceRight;
/**
 * @category type class operations
 * @since 3.0.0
 */
var traverse = function (F) {
    return function (f) {
        return function (t) {
            return (0, function_1.pipe)(f((0, exports.fst)(t)), F.map(function (b) { return [b, (0, exports.snd)(t)]; }));
        };
    };
};
exports.traverse = traverse;
// -------------------------------------------------------------------------------------
// instances
// -------------------------------------------------------------------------------------
/**
 * @category instances
 * @since 3.0.0
 */
exports.Bifunctor = {
    bimap: exports.bimap,
    mapLeft: exports.mapSnd
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Functor = {
    map: exports.mapFst
};
/**
 * Derivable from `Functor`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.flap = (0, Functor_1.flap)(exports.Functor);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Semigroupoid = {
    compose: exports.compose
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Comonad = {
    map: exports.mapFst,
    extend: exports.extend,
    extract: exports.extract
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Foldable = {
    reduce: exports.reduce,
    foldMap: exports.foldMap,
    reduceRight: exports.reduceRight
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Traversable = {
    traverse: exports.traverse
};
/**
 * @since 3.0.0
 */
var sequence = function (F) {
    return (0, exports.traverse)(F)(function_1.identity);
};
exports.sequence = sequence;
/**
 * @category instances
 * @since 3.0.0
 */
var getPointed = function (M) { return ({
    of: function (a) { return [a, M.empty]; }
}); };
exports.getPointed = getPointed;
/**
 * @category instances
 * @since 3.0.0
 */
var getApply = function (S) { return ({
    map: exports.map,
    ap: function (fa) { return function (fab) {
        var f = fab[0], w1 = fab[1];
        var a = fa[0], w2 = fa[1];
        return [f(a), S.concat(w2)(w1)];
    }; }
}); };
exports.getApply = getApply;
/**
 * @category instances
 * @since 3.0.0
 */
var getApplicative = function (M) {
    var A = (0, exports.getApply)(M);
    var P = (0, exports.getPointed)(M);
    return {
        map: exports.map,
        ap: A.ap,
        of: P.of
    };
};
exports.getApplicative = getApplicative;
/**
 * @category instances
 * @since 3.0.0
 */
var getChain = function (S) {
    return {
        map: exports.map,
        chain: function (f) { return function (ma) {
            var a = ma[0], w1 = ma[1];
            var _a = f(a), b = _a[0], w2 = _a[1];
            return [b, S.concat(w2)(w1)];
        }; }
    };
};
exports.getChain = getChain;
/**
 * @category instances
 * @since 3.0.0
 */
var getMonad = function (M) {
    var P = (0, exports.getPointed)(M);
    var C = (0, exports.getChain)(M);
    return {
        map: exports.map,
        of: P.of,
        chain: C.chain
    };
};
exports.getMonad = getMonad;
/**
 * @category instances
 * @since 3.0.0
 */
function getChainRec(M) {
    var chainRec = function (f) {
        return function (a) {
            var result = f(a);
            var acc = M.empty;
            var s = (0, exports.fst)(result);
            while (_.isLeft(s)) {
                acc = M.concat((0, exports.snd)(result))(acc);
                result = f(s.left);
                s = (0, exports.fst)(result);
            }
            return [s.right, M.concat((0, exports.snd)(result))(acc)];
        };
    };
    return {
        chainRec: chainRec
    };
}
exports.getChainRec = getChainRec;
// -------------------------------------------------------------------------------------
// array utils
// -------------------------------------------------------------------------------------
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverseWithIndex(getApply(M))`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArrayWithIndex = function (S) {
    return function (f) {
        return function (as) {
            // TODO
            return ReadonlyNonEmptyArrayModule.traverseWithIndex((0, exports.getApply)(S))(f)(as);
        };
    };
};
exports.traverseReadonlyNonEmptyArrayWithIndex = traverseReadonlyNonEmptyArrayWithIndex;
/**
 * Equivalent to `ReadonlyArray#traverseWithIndex(getApplicative(M))`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArrayWithIndex = function (M) {
    return function (f) {
        var g = (0, exports.traverseReadonlyNonEmptyArrayWithIndex)(M)(f);
        return function (as) { return (_.isNonEmpty(as) ? g(as) : [_.emptyReadonlyArray, M.empty]); };
    };
};
exports.traverseReadonlyArrayWithIndex = traverseReadonlyArrayWithIndex;
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverse(getApply(S))`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArray = function (S) {
    var traverseReadonlyNonEmptyArrayWithIndexS = (0, exports.traverseReadonlyNonEmptyArrayWithIndex)(S);
    return function (f) {
        return traverseReadonlyNonEmptyArrayWithIndexS(function (_, a) { return f(a); });
    };
};
exports.traverseReadonlyNonEmptyArray = traverseReadonlyNonEmptyArray;
/**
 * Equivalent to `ReadonlyArray#traverse(getApplicative(M))`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArray = function (M) {
    var traverseReadonlyArrayWithIndexS = (0, exports.traverseReadonlyArrayWithIndex)(M);
    return function (f) {
        return traverseReadonlyArrayWithIndexS(function (_, a) { return f(a); });
    };
};
exports.traverseReadonlyArray = traverseReadonlyArray;
/**
 * Equivalent to `ReadonlyArray#sequence(getApplicative(M))`.
 *
 * @since 3.0.0
 */
var sequenceReadonlyArray = function (M) { return (0, exports.traverseReadonlyArray)(M)(function_1.identity); };
exports.sequenceReadonlyArray = sequenceReadonlyArray;
