"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ask = exports.has = exports.emptyRecord = exports.emptyReadonlyArray = exports.tail = exports.head = exports.isNonEmpty = exports.singleton = exports.fromNullableOrElse = exports.fromOption = exports.right = exports.left = exports.isRight = exports.isLeft = exports.fromNullable = exports.getRight = exports.getLeft = exports.some = exports.none = exports.isSome = exports.isNone = void 0;
var function_1 = require("./function");
// -------------------------------------------------------------------------------------
// Option
// -------------------------------------------------------------------------------------
/** @internal */
var isNone = function (fa) { return fa._tag === 'None'; };
exports.isNone = isNone;
/** @internal */
var isSome = function (fa) { return fa._tag === 'Some'; };
exports.isSome = isSome;
/** @internal */
exports.none = { _tag: 'None' };
/** @internal */
var some = function (a) { return ({ _tag: 'Some', value: a }); };
exports.some = some;
/** @internal */
var getLeft = function (ma) { return ((0, exports.isRight)(ma) ? exports.none : (0, exports.some)(ma.left)); };
exports.getLeft = getLeft;
/** @internal */
var getRight = function (ma) { return ((0, exports.isLeft)(ma) ? exports.none : (0, exports.some)(ma.right)); };
exports.getRight = getRight;
/** @internal */
var fromNullable = function (a) { return (a == null ? exports.none : (0, exports.some)(a)); };
exports.fromNullable = fromNullable;
// -------------------------------------------------------------------------------------
// Either
// -------------------------------------------------------------------------------------
/** @internal */
var isLeft = function (ma) { return ma._tag === 'Left'; };
exports.isLeft = isLeft;
/** @internal */
var isRight = function (ma) { return ma._tag === 'Right'; };
exports.isRight = isRight;
/** @internal */
var left = function (e) { return ({ _tag: 'Left', left: e }); };
exports.left = left;
/** @internal */
var right = function (a) { return ({ _tag: 'Right', right: a }); };
exports.right = right;
/** @internal */
var fromOption = function (onNone) {
    return function (fa) {
        return (0, exports.isNone)(fa) ? (0, exports.left)(onNone()) : (0, exports.right)(fa.value);
    };
};
exports.fromOption = fromOption;
/** @internal */
var fromNullableOrElse = function (onNullable) {
    return function (a) {
        return a == null ? (0, exports.left)(onNullable()) : (0, exports.right)(a);
    };
};
exports.fromNullableOrElse = fromNullableOrElse;
// -------------------------------------------------------------------------------------
// ReadonlyNonEmptyArray
// -------------------------------------------------------------------------------------
/** @internal */
var singleton = function (a) { return [a]; };
exports.singleton = singleton;
/** @internal */
var isNonEmpty = function (as) { return as.length > 0; };
exports.isNonEmpty = isNonEmpty;
/** @internal */
var head = function (as) { return as[0]; };
exports.head = head;
/** @internal */
var tail = function (as) { return as.slice(1); };
exports.tail = tail;
// -------------------------------------------------------------------------------------
// empty
// -------------------------------------------------------------------------------------
/** @internal */
exports.emptyReadonlyArray = [];
/** @internal */
exports.emptyRecord = {};
// -------------------------------------------------------------------------------------
// Record
// -------------------------------------------------------------------------------------
/** @internal */
exports.has = Object.prototype.hasOwnProperty;
// -------------------------------------------------------------------------------------
// Reader
// -------------------------------------------------------------------------------------
/** @internal */
var ask = function () { return function_1.identity; };
exports.ask = ask;
