/**
 * @since 3.0.0
 */
import { identity } from './function';
// -------------------------------------------------------------------------------------
// defaults
// -------------------------------------------------------------------------------------
/**
 * Return a default `mapLeft` implementation from `bimap`.
 *
 * @category defaults
 * @since 3.0.0
 */
export const mapLeftDefault = (bimap) => (f) => bimap(f, identity);
/**
 * Return a default `map` implementation from `bimap`.
 *
 * @category defaults
 * @since 3.0.0
 */
export const mapDefault = (bimap) => (f) => bimap(identity, f);
