import * as _ from './internal';
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
export const filterWithIndex = (F) => (predicate) => F.filterMapWithIndex((i, b) => (predicate(i, b) ? _.some(b) : _.none));
/**
 * @category combinators
 * @since 3.0.0
 */
export const refineWithIndex = (F) => (refinement) => F.filterMapWithIndex((i, c) => (refinement(i, c) ? _.some(c) : _.none));
/**
 * @category combinators
 * @since 3.0.0
 */
export const partitionWithIndex = (F) => (predicate) => F.partitionMapWithIndex((i, b) => (predicate(i, b) ? _.right(b) : _.left(b)));
/**
 * @category combinators
 * @since 3.0.0
 */
export const refinementWithIndex = (F) => (refinement) => F.partitionMapWithIndex((i, c) => (refinement(i, c) ? _.right(c) : _.left(c)));
