/**
 * Lift a computation from the `IO` monad.
 *
 * @since 3.0.0
 */
import * as ChainModule from './Chain';
import { pipe } from './function';
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
export const fromIOK = (F) => (f) => (...a) => F.fromIO(f(...a));
/**
 * @category combinators
 * @since 3.0.0
 */
export const chainIOK = (F, M) => (f) => (ma) => {
    return pipe(ma, M.chain((a) => F.fromIO(f(a))));
};
/**
 * @category combinators
 * @since 3.0.0
 */
export const chainFirstIOK = (F, M) => {
    const chainFirstM = ChainModule.chainFirst(M);
    return (f) => chainFirstM((a) => F.fromIO(f(a)));
};
