/**
 * Lift a computation from the `Task` monad.
 *
 * @since 3.0.0
 */
import * as ChainModule from './Chain';
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
export const fromTaskK = (F) => (f) => (...a) => F.fromTask(f(...a));
/**
 * @category combinators
 * @since 3.0.0
 */
export const chainTaskK = (F, M) => {
    return (f) => M.chain((a) => F.fromTask(f(a)));
};
/**
 * @category combinators
 * @since 3.0.0
 */
export const chainFirstTaskK = (F, M) => {
    const chainFirstM = ChainModule.chainFirst(M);
    return (f) => chainFirstM((a) => F.fromTask(f(a)));
};
