import { flow, pipe } from './function';
/**
 * @since 3.0.0
 */
export function of(F) {
    return (a) => () => F.of(a);
}
/**
 * @since 3.0.0
 */
export function map(F) {
    return (f) => (fa) => flow(fa, F.map(f));
}
/**
 * @since 3.0.0
 */
export const ap = (F) => {
    return (fa) => (fab) => (r) => F.ap(fa(r))(fab(r));
};
/**
 * @since 3.0.0
 */
export const chain = (M) => (f) => (ma) => {
    return (r) => pipe(ma(r), M.chain((a) => f(a)(r)));
};
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
export const fromReader = (F) => (ma) => {
    return (r) => F.of(ma(r));
};
/**
 * @category constructors
 * @since 3.0.0
 */
export function fromNaturalTransformation(nt) {
    return (f) => flow(f, nt);
}
