import { identity } from './function';
// -------------------------------------------------------------------------------------
// Option
// -------------------------------------------------------------------------------------
/** @internal */
export const isNone = (fa) => fa._tag === 'None';
/** @internal */
export const isSome = (fa) => fa._tag === 'Some';
/** @internal */
export const none = { _tag: 'None' };
/** @internal */
export const some = (a) => ({ _tag: 'Some', value: a });
/** @internal */
export const getLeft = (ma) => (isRight(ma) ? none : some(ma.left));
/** @internal */
export const getRight = (ma) => (isLeft(ma) ? none : some(ma.right));
/** @internal */
export const fromNullable = (a) => (a == null ? none : some(a));
// -------------------------------------------------------------------------------------
// Either
// -------------------------------------------------------------------------------------
/** @internal */
export const isLeft = (ma) => ma._tag === 'Left';
/** @internal */
export const isRight = (ma) => ma._tag === 'Right';
/** @internal */
export const left = (e) => ({ _tag: 'Left', left: e });
/** @internal */
export const right = (a) => ({ _tag: 'Right', right: a });
/** @internal */
export const fromOption = (onNone) => (fa) => isNone(fa) ? left(onNone()) : right(fa.value);
/** @internal */
export const fromNullableOrElse = (onNullable) => (a) => a == null ? left(onNullable()) : right(a);
// -------------------------------------------------------------------------------------
// ReadonlyNonEmptyArray
// -------------------------------------------------------------------------------------
/** @internal */
export const singleton = (a) => [a];
/** @internal */
export const isNonEmpty = (as) => as.length > 0;
/** @internal */
export const head = (as) => as[0];
/** @internal */
export const tail = (as) => as.slice(1);
// -------------------------------------------------------------------------------------
// empty
// -------------------------------------------------------------------------------------
/** @internal */
export const emptyReadonlyArray = [];
/** @internal */
export const emptyRecord = {};
// -------------------------------------------------------------------------------------
// Record
// -------------------------------------------------------------------------------------
/** @internal */
export const has = Object.prototype.hasOwnProperty;
// -------------------------------------------------------------------------------------
// Reader
// -------------------------------------------------------------------------------------
/** @internal */
export const ask = () => identity;
