import type { Functor } from './Functor'
import type { HKT, Kind, Typeclass } from './HKT'
/**
 * @category type classes
 * @since 3.0.0
 */
export interface Bifunctor<F extends HKT> extends Typeclass<F> {
  readonly bimap: <E, G, A, B>(
    f: (e: E) => G,
    g: (a: A) => B
  ) => <S, R, W>(fea: Kind<F, S, R, W, E, A>) => Kind<F, S, R, W, G, B>
  readonly mapLeft: <E, G>(f: (e: E) => G) => <S, R, W, A>(fea: Kind<F, S, R, W, E, A>) => Kind<F, S, R, W, G, A>
}
/**
 * Return a default `mapLeft` implementation from `bimap`.
 *
 * @category defaults
 * @since 3.0.0
 */
export declare const mapLeftDefault: <F extends HKT>(
  bimap: <E, G, A, B>(
    f: (e: E) => G,
    g: (a: A) => B
  ) => <S, R, W>(fea: Kind<F, S, R, W, E, A>) => Kind<F, S, R, W, G, B>
) => <E_1, G_1>(
  f: (e: E_1) => G_1
) => <S_1, R_1, W_1, A_1>(fea: Kind<F, S_1, R_1, W_1, E_1, A_1>) => Kind<F, S_1, R_1, W_1, G_1, A_1>
/**
 * Return a default `map` implementation from `bimap`.
 *
 * @category defaults
 * @since 3.0.0
 */
export declare const mapDefault: <F extends HKT>(
  bimap: <E, G, A, B>(
    f: (e: E) => G,
    g: (a: A) => B
  ) => <S, R, W>(fea: Kind<F, S, R, W, E, A>) => Kind<F, S, R, W, G, B>
) => <A_1, B_1>(
  f: (a: A_1) => B_1
) => <S_1, R_1, W_1, E_1>(fa: Kind<F, S_1, R_1, W_1, E_1, A_1>) => Kind<F, S_1, R_1, W_1, E_1, B_1>
