/**
 * A `DistributiveLattice` must satisfy the following laws in addition to `Lattice` laws:
 *
 * - Distributivity for meet: `a ∨ (b ∧ c) <-> (a ∨ b) ∧ (a ∨ c)`
 * - Distributivity for join: `a ∧ (b ∨ c) <-> (a ∧ b) ∨ (a ∧ c)`
 *
 * @since 3.0.0
 */
import type { Lattice } from './Lattice'
import * as OrdModule from './Ord'
import Ord = OrdModule.Ord
/**
 * @category type classes
 * @since 3.0.0
 */
export interface DistributiveLattice<A> extends Lattice<A> {}
/**
 * @category constructors
 * @since 3.0.0
 */
export declare const getMinMaxDistributiveLattice: <A>(O: OrdModule.Ord<A>) => DistributiveLattice<A>
