/**
 * The `FromWriter` type class represents those data types which support accumulators.
 *
 * @since 3.0.0
 */
import type { HKT, Kind, Typeclass } from './HKT'
import type { Writer } from './Writer'
/**
 * @category type classes
 * @since 3.0.0
 */
export interface FromWriter<F extends HKT> extends Typeclass<F> {
  readonly fromWriter: <E, A, S, R = unknown, W = never>(fa: Writer<E, A>) => Kind<F, S, R, W, E, A>
}
/**
 * @category combinators
 * @since 3.0.0
 */
export declare const fromWriterK: <F extends HKT>(
  F: FromWriter<F>
) => <A extends readonly unknown[], E, B>(
  f: (...a: A) => Writer<E, B>
) => <S, R = unknown, W = never>(...a: A) => Kind<F, S, R, W, E, B>
