/**
 * @since 3.0.0
 */
import * as EqModule from './Eq'
import * as MonoidModule from './Monoid'
import * as SemigroupModule from './Semigroup'
/**
 * @category model
 * @since 3.0.0
 */
export declare type Ordering = -1 | 0 | 1
/**
 * @category combinators
 * @since 3.0.0
 */
export declare const reverse: (o: Ordering) => Ordering
/**
 * @category destructors
 * @since 3.0.0
 */
export declare const match: <A, B, C = B>(
  onLessThan: () => A,
  onEqual: () => B,
  onGreaterThan: () => C
) => (o: Ordering) => A | B | C
/**
 * @category instances
 * @since 3.0.0
 */
export declare const Eq: EqModule.Eq<Ordering>
/**
 * @category instances
 * @since 3.0.0
 */
export declare const Semigroup: SemigroupModule.Semigroup<Ordering>
/**
 * @category instances
 * @since 3.0.0
 */
export declare const Monoid: MonoidModule.Monoid<Ordering>
/**
 * @since 3.0.0
 */
export declare const sign: (n: number) => Ordering
