/**
 * @since 3.0.0
 */
import * as ContravariantModule from './Contravariant'
import type { HKT } from './HKT'
import type { Monoid } from './Monoid'
import type { Semigroup } from './Semigroup'
/**
 * @since 3.0.0
 */
export interface Predicate<A> {
  (a: A): boolean
}
/**
 * @category Contravariant
 * @since 3.0.0
 */
export declare const contramap: <B, A>(f: (b: B) => A) => (fa: Predicate<A>) => Predicate<B>
/**
 * @category HKT
 * @since 3.0.0
 */
export interface PredicateF extends HKT {
  readonly type: Predicate<this['Contravariant1']>
}
/**
 * @category instances
 * @since 3.0.0
 */
export declare const getSemigroupAny: <A = never>() => Semigroup<Predicate<A>>
/**
 * @category instances
 * @since 3.0.0
 */
export declare const getMonoidAny: <A = never>() => Monoid<Predicate<A>>
/**
 * @category instances
 * @since 3.0.0
 */
export declare const getSemigroupAll: <A = never>() => Semigroup<Predicate<A>>
/**
 * @category instances
 * @since 3.0.0
 */
export declare const getMonoidAll: <A = never>() => Monoid<Predicate<A>>
/**
 * @category instances
 * @since 3.0.0
 */
export declare const Contravariant: ContravariantModule.Contravariant<PredicateF>
/**
 * @since 3.0.0
 */
export declare const not: <A>(predicate: Predicate<A>) => Predicate<A>
/**
 * @since 3.0.0
 */
export declare const or: <A>(second: Predicate<A>) => (first: Predicate<A>) => Predicate<A>
/**
 * @since 3.0.0
 */
export declare const and: <A>(second: Predicate<A>) => (first: Predicate<A>) => Predicate<A>
